/*
 * Copyright (c) 1983 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
/*+:EDITS:*/
/*:05-08-1990-15:55-wht@n4hgf-rawthru */

#ifndef lint
static char sccsid[] = "@(#)cmdtab.c	5.5 (Berkeley) 9/2/88";
#endif /* not lint */

#include "tip.h"

extern	void shell(), getfl(), sendfile(), chdirectory(),variable();
extern	void finish(), help(), pipefile(), pipeout(), consh();
extern	void cu_take(), cu_put(), dollar(), genbrk(), suspend();

/* tipx */
extern void genctls(), genctlq(), rawthru_control();
extern void filexfer();

esctable_t etable[] = {
	{ '!',		"shell",			 shell },
	{ '<',		"receive file from remote host", getfl },
	{ '>',		"send file to remote host", sendfile },
	{ 't',		"take file from remote UNIX", cu_take },
	{ 'p',		"put file to remote UNIX", cu_put },
	{ '|',		"pipe remote file", pipefile },
	{ '$',		"pipe local command to remote host", pipeout },
#ifdef CONNECT
	{ 'C',  	"connect program to remote host",consh },
#endif
	{ 'c',		"change directory", chdirectory },
	{ '.',		"exit from tip", finish },
	{CTRL('d'), "exit from tip",	 finish },
	{CTRL('y'), "suspend tip (local+remote)", suspend },
	{CTRL('z'), "suspend tip (local only)", suspend },
	{ 's',		"set variable",	 variable },
	{ '?',		"get this summary",	 help },
	{ '#',		"send break", genbrk },
	{ 'R',		"set rawthru mode", rawthru_control },
	{ 'N',		"no rawthru mode",	rawthru_control },
	{ 'X',  	"X/Y/ZMODEM/B+ send/receive",filexfer },
	{ 0, NULL, NULL }
};
