/*
 * Copyright (c) 1995  Kenji Arisawa. All right reserved.
 * License to freely use and distribute this software is hereby granted 
 * by the author, subject to the condition that this copyright notice 
 * remains intact.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES.
 *
 *
 * tip+ configuration file
 * -Kenar-
 */

/* ------ config.h for BSD( SunOS4, BreeBSD, BSDOS, NeXT ) --------
 * Under make options:
 * CFLAGS= -O -DDEFBR=19200 -DDEFFS=BUFSIZ -DCONNECT
 */

/* ----------------------------------------------------------------
 * Include files may be system dependent */
#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <setjmp.h>
#include <errno.h>
#include <strings.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/stat.h>

/*
 * PRE-DEFINED MACROS
 * -- Macros that are automatically defined in preprocessor. --
 * NeXT: NeXT
 * SUN4: ?
 * FreeBSD: __FreeBSD__
 * BSD/OS: ?
 * ** Please let me know the macro '?' if you know.
 * ** E-mail: arisawa@aichi-u.ac.jp
 *
 * WE SHOULD DEFINE IN COMPILER -D OPTION
 * FreeBSD: FBSD
 * BSD/OS:  FBSD
 */




#define USE_IOCTL
#ifdef FBSD
#define USE_IOCTL_COMPT
#define USE_OLD_TTY
#define USE_TTYDEV
#endif

/* ----------------------------------------------------------------
 * Configure as you like. Change Makefile if you touch. */
#define ACUFMT	"/etc/acu/%s.tip+"
#define SLIPFMT	"/etc/slip/%s.tip+"

/* ----------------------------------------------------------------
 * The path to aculog may be system dependent.
 * For FreeBSD and BSD/OS it may be:
 *    /var/adm/aculog
 * Change Makefile if you touch.
 * cc option: -DACULOG=\"$(ACULOG)\"
 * may be more elegant if you want to change.
 */
#ifndef ACULOG
#ifdef FBSD
#define ACULOG "/var/log/aculog"
#else
#define ACULOG "/usr/adm/aculog"
#endif
#endif

/* ----------------------------------------------------------------
 * uucp lock dir. may be system dependent */
#ifdef FBSD
#define LOCKDIRFMT	"/var/spool/lock/LCK..%s"
#else
#define LOCKDIRFMT	"/usr/spool/uucp/LCK/LCK..%s"
#endif

/* ----------------------------------------------------------------
 * The type definition of signal function is system dependent.
 * That may be (int) or (void).
 * Man signal of NeXT says,
 *	   include <signal.h>
 *     (*signal(sig, func))()  int (*func)();
 * However roughly speaking,
 * #if (defined(__STRICT_ANSI__) && !defined(_POSIX_SOURCE))
 *    void (*signal(int sig, void (*func)(int)))(int);
 * #elseif
 *   #ifdef __STRICT_BSD__
 *	  int (*signal(int, int (*)()))();
 *	 #else
 *	  void (*signal(int, void (*)(int)))(int);
 *   #endif
 * #endif
 *
 * Don't declare signal function 'sigfunc' such like,
 *   sigfunc_t sigfunc(void);
 * but delare
 *   sigfunc_t sigfunc();
 * even if it has no argument.
 * -Kenar-
 */
typedef void sigfunc_t;


/* ------------ file lock -------------- */
#define fexlock(fd)   flock(fd, LOCK_EX)
#define funlock(fd)   flock(fd, LOCK_UN)
