/*
 * Copyright (c) 1983 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef lint
static char sccsid[] = "@(#)log.c	5.3 (Berkeley) 9/2/88";
#endif /* not lint */

#include <pwd.h>
#include <grp.h>
#include "tip.h"

extern int suidmode; /* defined in tip.c */
extern uid_t uid; /* defined in tip.c */
static	FILE *flog = NULL;
static char *user=NULL;

#ifdef PRISTINE
int pristine = 1;	/* so it is easier to change for binary-only sites */
#else
int pristine = 0;
#endif

/*
 * Log file maintenance routines
 */

void logent(host, num, acu, message)
	char *host, *num, *acu, *message;
{
  	long t;
	char *timestamp;

	if (!suidmode || !flog) return;
	
	if (fexlock(fileno(flog)) < 0) {
		perror("tip: aculog is locked");
		return;
	}
	t = time(0);
	timestamp = ctime(&t);
	timestamp[24] = '\0';
	/* tip+ uses tip format: (not tipx format that puts 'group') */
	fprintf(flog, "%s (%s) <%s, %s, %s> %s\n",
		user, timestamp, host,
		pristine ? "" : num,
		acu, message);
	fflush(flog);
	funlock(fileno(flog));
}

void loginit(logfile)
char *logfile;
{
	struct passwd *pwd;

	if(!suidmode) return;

  	flog = fopen(logfile, "a");
	if (flog == NULL) {
		fprintf(stderr, "tip: can't open log file: %s\r\n", logfile);
		exit(3);
	}
	
	setpwent();
	if ((pwd = getpwuid(uid)) == NOPWD)
		user = "???";
	else
		user = pwd->pw_name;
}
