/*
 * Copyright (c) 1995  Kenji Arisawa. All right reserved.
 * License to freely use and distribute this software is hereby granted 
 * by the author, subject to the condition that this copyright notice 
 * remains intact.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES.
 */
#ifndef lint
static char sccsid[] = "@(#)posix.c	1.0 (Kenar) 2/6/96";
#endif /* not lint */



/* ------------------ Now INCOMPLETE! ----------------------- */



#include <termios.h>

#define YES 1
#define NO 0

typedef int boolean;

boolean rawflag = NO; /* Is in rawmode ? */

/* terminal data */
static struct termios	ttybc; /* current data of local terminal */
static struct termios	ttybi; /* initial data of local terminal */
static struct termios 	ttybl; /* line data */



/* ------------ tty control functions -------------------*/

/*
 * put the controlling keyboard into raw mode
 */
void tio_raw()
{	static boolean done = NO;

	if(!done){
		tcgetattr(0, &ttybi);
		ttybc = ttybi;
		ttybc.c_cc[VINTR] = '\003';
		ttybc.c_cc[VMIN] = 1;
		ttybc.c_cc[VTIME] = 0;
		ttybc.c_iflag = 0;
		ttybc.c_oflag = 0;
		ttybc.c_cflag = CS8;  /* 8 bits char */
		ttybc.c_lflag = ISIG; /* allows CBREAK */
		done = YES;
	}
	tcsetattr(0, TCSAFLUSH, &ttybc);
	rawflag = YES;
}


/*
 * return keyboard to normal mode
 */
void tio_unraw()
{
	tcsetattr(0, TCSAFLUSH, &ttybi);
	rawflag = NO;
}

/* set/clear cbreak */
void tio_cbreak(mode)
boolean mode;
{
	if(mode) ttybc.c_lflag |= ISIG; /* allows CBREAK */
	else 	 ttybc.c_lflag &= ~ISIG; /* disable CBREAK */
	tcsetattr(0, TCSANOW, &ttybc);
}


/* set/clear tandem */
void tio_tandem(mode)
boolean mode;
{
	if(mode) ttybc.c_iflag |= IXON|IXOFF;
	else	 ttybc.c_iflag &= ~(IXON|IXOFF);
	tcsetattr(0, TCSANOW, &ttybc);
}


/* ---------------- I/O control for modem -------------------- */

/*
 * Set up the "remote" tty's state
 */
void ttysetup(fd,baudcode,tandmode)
int fd;
int baudcode; /* speed is given by baud code - Kenar - */
boolean tandmode; /* tandem mode */
{
	tcgetattr(fd, &ttybl);
	ttybl.c_cc[VMIN] = 1;
	ttybl.c_cc[VTIME] = 0;
	ttybl.c_iflag = 0;
	ttybl.c_oflag = 0;
	ttybl.c_cflag = CS8;
	ttybl.c_lflag = NOFLSH;
	if(tandmode) ttybl.c_iflag = IXON|IXOFF;
	cfsetispeed(&ttybl,baudcode);
	cfsetospeed(&ttybl,baudcode);
	tcsetattr(fd, TCSAFLUSH, &ttybl);
}

void clrdtr(fd) /* clear data terminal ready */
int fd;
{
	ioctl(fd, TIOCCDTR, 0); /* may be passed (you may ignore) */
}

void setdtr(fd) /* set data terminal ready */
int fd;
{
	ioctl(fd, TIOCSDTR, 0); /* may be passed (you may ignore) */
}

void iflush(fd) /* flush input buf to remove echo garbage */
int fd;
{
	tcflush(fd, TCIFLUSH);
}

int nread(fd) /* get data size to read */
int fd;
{	int n;
	/* FIONREAD is not supported by POSIX! */
	ioctl(fd, FIONREAD, &n); /* may be passed */
	return n;
}

void setxlock(fd)  /* Set exclusive use of tty */
int fd;
{
	ioctl(fd, TIOCEXCL, 0); /* may be passed (you may ignore) */
}

void sethup(fd) /* Hang up on last close. (disconnect modem line) */
int fd;
{
	ttybl.c_cflag |= HUPCL;
	tcsetattr(fd, TCSANOW, &ttybl);
}

void sendbrk(fd,msec) /* send break ( mili second ) */
int fd;
int msec;
{
	/* msec is ignored in POSIX case */
	tcsendbreak(fd,0); /* 0.25 ~ 0.5 sec. break. (system dependent) */
}

/* set/clear tandem */
void io_tandem(fd,cntl)
int fd;
boolean cntl;
{
	if(cntl) ttybl.c_iflag |= IXON|IXOFF;
	else ttybl.c_iflag &= ~(IXON|IXOFF);
	tcsetattr(fd, TCSANOW, &ttybl);
}


/* ---------------- Lock file -------------------- */
int flocl(fd,opt)
inf fd, opt;
{	;
}
